import { PDFDocumentProxy, PDFPageProxy } from 'pdfjs-dist';

declare type HookProps = {
    canvasRef: React.RefObject<HTMLCanvasElement | null>;
    file: string;
    onDocumentLoadSuccess?: (document: PDFDocumentProxy) => void;
    onDocumentLoadFail?: () => void;
    onPageLoadSuccess?: (page: PDFPageProxy) => void;
    onPageLoadFail?: () => void;
    onPageRenderSuccess?: (page: PDFPageProxy) => void;
    onPageRenderFail?: () => void;
    scale?: number;
    rotate?: number;
    page?: number;
    cMapUrl?: string;
    cMapPacked?: boolean;
    workerSrc?: string;
    withCredentials?: boolean;
};
declare type HookReturnValues = {
    pdfDocument: PDFDocumentProxy | undefined;
    pdfPage: PDFPageProxy | undefined;
};
declare const usePdf: ({ canvasRef, file, onDocumentLoadSuccess, onDocumentLoadFail, onPageLoadSuccess, onPageLoadFail, onPageRenderSuccess, onPageRenderFail, scale, rotate, page, cMapUrl, cMapPacked, workerSrc, withCredentials, }: HookProps) => HookReturnValues;

export { usePdf };
